## $Id: viewlets.py 12762 2015-03-14 13:49:29Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Viewlet components for products offered by the company.
"""

import grok
from waeup.ikoba.browser.viewlets import (
    PrimaryNavTab, ManageActionButton, AddActionButton)
from waeup.ikoba.interfaces import IIkobaObject
from waeup.ikoba.interfaces import MessageFactory as _
from waeup.ikoba.browser.viewlets import PrimaryNavTab

from waeup.ikoba.products.interfaces import (
    IProductsContainer, IProduct)
from waeup.ikoba.products.browser import (
    ProductsContainerManageFormPage, ProductsContainerPage,
    ProductManageFormPage, ProductDisplayFormPage)


grok.context(IIkobaObject)  # Make IIkobaObject the default context
grok.templatedir('browser_templates')


class ProductsTab(PrimaryNavTab):
    """Products tab in primary navigation.
    """

    grok.context(IIkobaObject)
    grok.order(2)
    grok.require('waeup.Public')
    grok.name('productstab')

    pnav = 1
    tab_title = _(u'Products')

    @property
    def link_target(self):
        return self.view.application_url('products')

class ProductsContainerManageActionButton(ManageActionButton):
    grok.order(1)
    grok.context(IProductsContainer)
    grok.view(ProductsContainerPage)
    grok.require('waeup.manageProducts')
    text = _('Manage')
    target = 'manage'


class ProductViewActionButton(ManageActionButton):
    grok.order(1)
    grok.context(IProduct)
    grok.view(ProductManageFormPage)
    grok.require('waeup.manageProducts')
    text = _('View')
    target = 'index'
    icon = 'actionicon_view.png'


class ProductManageActionButton(ManageActionButton):
    grok.order(1)
    grok.context(IProduct)
    grok.view(ProductDisplayFormPage)
    grok.require('waeup.manageProducts')
    text = _('Manage')
    target = 'manage'
